#!/bin/bash
# josejp2424
# Environment variables and language configurations
export TEXTDOMAIN=locale-keyboard
export OUTPUT_CHARSET=UTF-8
export pics=/usr/share/pixmaps/locale-keyboard/
ICON_PATH="/usr/share/pixmaps/locale-keyboard/preferencesdesktoplocale.svg"

# Translated titles
mytitle41=$(gettext 'English (United States)')
mytitle1=$(gettext 'Afar (Djibouti)')
mytitle2=$(gettext 'Afar (Eritrea)')
mytitle3=$(gettext 'Afrikaans (South Africa)')
mytitle4=$(gettext 'Akan (Ghana)')
mytitle5=$(gettext 'Amharic (Ethiopia)')
mytitle6=$(gettext 'Aragonese (Spain)')
mytitle7=$(gettext 'Arabic (UAE)')
mytitle8=$(gettext 'Arabic (Bahrain)')
mytitle9=$(gettext 'Arabic (Algeria)')
mytitle10=$(gettext 'Arabic (Egypt)')
mytitle11=$(gettext 'Arabic (Iraq)')
mytitle12=$(gettext 'Arabic (Jordan)')
mytitle13=$(gettext 'Arabic (Kuwait)')
mytitle14=$(gettext 'Arabic (Lebanon)')
mytitle15=$(gettext 'Arabic (Libya)')
mytitle16=$(gettext 'Arabic (Morocco)')
mytitle17=$(gettext 'Arabic (Oman)')
mytitle18=$(gettext 'Arabic (Qatar)')
mytitle19=$(gettext 'Arabic (Saudi Arabia)')
mytitle20=$(gettext 'Arabic (Sudan)')
mytitle21=$(gettext 'Arabic (Syria)')
mytitle22=$(gettext 'Arabic (Tunisia)')
mytitle23=$(gettext 'Arabic (Yemen)')
mytitle24=$(gettext 'Azerbaijani (Azerbaijan)')
mytitle25=$(gettext 'Azerbaijani (Iran)')
mytitle26=$(gettext 'Bashkir (Russia)')
mytitle27=$(gettext 'Bengali (Bangladesh)')
mytitle28=$(gettext 'Bengali (India)')
mytitle29=$(gettext 'Bosnian (Bosnia and Herzegovina)')
mytitle30=$(gettext 'Bulgarian (Bulgaria)')
mytitle31=$(gettext 'Catalan (Spain)')
mytitle32=$(gettext 'Chinese (Simplified)')
mytitle33=$(gettext 'Chinese (Traditional)')
mytitle34=$(gettext 'Croatian (Croatia)')
mytitle35=$(gettext 'Czech (Czech Republic)')
mytitle36=$(gettext 'Danish (Denmark)')
mytitle37=$(gettext 'Dutch (Netherlands)')
mytitle38=$(gettext 'English (Australia)')
mytitle39=$(gettext 'English (Canada)')
mytitle40=$(gettext 'English (United Kingdom)')
mytitle42=$(gettext 'Estonian (Estonia)')
mytitle43=$(gettext 'Finnish (Finland)')
mytitle44=$(gettext 'French (Belgium)')
mytitle45=$(gettext 'French (Canada)')
mytitle46=$(gettext 'French (France)')
mytitle47=$(gettext 'German (Austria)')
mytitle48=$(gettext 'German (Germany)')
mytitle49=$(gettext 'German (Switzerland)')
mytitle50=$(gettext 'Greek (Greece)')
mytitle51=$(gettext 'Hebrew (Israel)')
mytitle52=$(gettext 'Hindi (India)')
mytitle53=$(gettext 'Hungarian (Hungary)')
mytitle54=$(gettext 'Icelandic (Iceland)')
mytitle55=$(gettext 'Indonesian (Indonesia)')
mytitle56=$(gettext 'Irish (Ireland)')
mytitle57=$(gettext 'Italian (Italy)')
mytitle58=$(gettext 'Japanese (Japan)')
mytitle59=$(gettext 'Kazakh (Kazakhstan)')
mytitle60=$(gettext 'Korean (South Korea)')
mytitle61=$(gettext 'Latvian (Latvia)')
mytitle62=$(gettext 'Lithuanian (Lithuania)')
mytitle63=$(gettext 'Macedonian (North Macedonia)')
mytitle64=$(gettext 'Malay (Malaysia)')
mytitle65=$(gettext 'Maltese (Malta)')
mytitle66=$(gettext 'Norwegian (Norway)')
mytitle67=$(gettext 'Persian (Iran)')
mytitle68=$(gettext 'Polish (Poland)')
mytitle69=$(gettext 'Portuguese (Brazil)')
mytitle70=$(gettext 'Portuguese (Portugal)')
mytitle71=$(gettext 'Romanian (Romania)')
mytitle72=$(gettext 'Russian (Russia)')
mytitle73=$(gettext 'Serbian (Serbia)')
mytitle74=$(gettext 'Slovak (Slovakia)')
mytitle75=$(gettext 'Slovenian (Slovenia)')
mytitle76=$(gettext 'Spanish (Argentina)')
mytitle77=$(gettext 'Spanish (Bolivia)')
mytitle78=$(gettext 'Spanish (Chile)')
mytitle79=$(gettext 'Spanish (Colombia)')
mytitle80=$(gettext 'Spanish (Costa Rica)')
mytitle81=$(gettext 'Spanish (Cuba)')
mytitle82=$(gettext 'Spanish (Dominican Republic)')
mytitle83=$(gettext 'Spanish (Ecuador)')
mytitle84=$(gettext 'Spanish (El Salvador)')
mytitle85=$(gettext 'Spanish (Spain)')
mytitle86=$(gettext 'Spanish (Guatemala)')
mytitle87=$(gettext 'Spanish (Honduras)')
mytitle88=$(gettext 'Spanish (Mexico)')
mytitle89=$(gettext 'Spanish (Nicaragua)')
mytitle90=$(gettext 'Spanish (Panama)')
mytitle91=$(gettext 'Spanish (Paraguay)')
mytitle92=$(gettext 'Spanish (Peru)')
mytitle93=$(gettext 'Spanish (Puerto Rico)')
mytitle94=$(gettext 'Spanish (Uruguay)')
mytitle95=$(gettext 'Spanish (Venezuela)')
mytitle96=$(gettext 'Swedish (Sweden)')
mytitle97=$(gettext 'Thai (Thailand)')
mytitle98=$(gettext 'Turkish (Turkey)')
mytitle99=$(gettext 'Ukrainian (Ukraine)')
mytitle100=$(gettext 'Vietnamese (Vietnam)')
mytitle101=$(gettext 'Welsh (United Kingdom)')
mytitle=$(gettext 'System Configuration')
mytitle0=$(gettext 'Cancel ')
mytitle102=$(gettext 'Keyboard language')
mytitle103=$(gettext 'System language')
mytitle104=$(gettext 'Time Zone')
mytitle105=$(gettext 'Apply changes')
mytitle106=$(gettext 'The language, keyboard, and time zone changes have been applied. You may need to reboot your system for the changes to take effect.')

# Supported languages
LANGUAGES=(
    "English (United States):en:en_US.UTF-8"
    "Afar (Djibouti):aa:aa_DJ.UTF-8"
    "Afar (Eritrea):aa:aa_ER.UTF-8"
    "Afrikaans (South Africa):af:af_ZA.UTF-8"
    "Akan (Ghana):ak:ak_GH.UTF-8"
    "Amharic (Ethiopia):am:am_ET.UTF-8"
    "Aragonese (Spain):an:an_ES.UTF-8"
    "Arabic (UAE):ar:ar_AE.UTF-8"
    "Arabic (Bahrain):ar:ar_BH.UTF-8"
    "Arabic (Algeria):ar:ar_DZ.UTF-8"
    "Arabic (Egypt):ar:ar_EG.UTF-8"
    "Arabic (Iraq):ar:ar_IQ.UTF-8"
    "Arabic (Jordan):ar:ar_JO.UTF-8"
    "Arabic (Kuwait):ar:ar_KW.UTF-8"
    "Arabic (Lebanon):ar:ar_LB.UTF-8"
    "Arabic (Libya):ar:ar_LY.UTF-8"
    "Arabic (Morocco):ar:ar_MA.UTF-8"
    "Arabic (Oman):ar:ar_OM.UTF-8"
    "Arabic (Qatar):ar:ar_QA.UTF-8"
    "Arabic (Saudi Arabia):ar:ar_SA.UTF-8"
    "Arabic (Sudan):ar:ar_SD.UTF-8"
    "Arabic (Syria):ar:ar_SY.UTF-8"
    "Arabic (Tunisia):ar:ar_TN.UTF-8"
    "Arabic (Yemen):ar:ar_YE.UTF-8"
    "Azerbaijani (Azerbaijan):az:az_AZ.UTF-8"
    "Azerbaijani (Iran):az:az_IR.UTF-8"
    "Bashkir (Russia):ba:bhb_IN.UTF-8"
    "Bengali (Bangladesh):bn:bn_BD.UTF-8"
    "Bengali (India):bn:bn_IN.UTF-8"
    "Bosnian (Bosnia and Herzegovina):bs:bs_BA.UTF-8"
    "Bulgarian (Bulgaria):bg:bg_BG.UTF-8"
    "Catalan (Spain):ca:ca_ES.UTF-8"
    "Chinese (Simplified):zh:zh_CN.UTF-8"
    "Chinese (Traditional):zh:zh_TW.UTF-8"
    "Croatian (Croatia):hr:hr_HR.UTF-8"
    "Czech (Czech Republic):cs:cs_CZ.UTF-8"
    "Danish (Denmark):da:da_DK.UTF-8"
    "Dutch (Netherlands):nl:nl_NL.UTF-8"
    "English (Australia):en:en_AU.UTF-8"
    "English (Canada):en:en_CA.UTF-8"
    "English (United Kingdom):en:en_GB.UTF-8"
    "Estonian (Estonia):et:et_EE.UTF-8"
    "Finnish (Finland):fi:fi_FI.UTF-8"
    "French (Belgium):fr:fr_BE.UTF-8"
    "French (Canada):fr:fr_CA.UTF-8"
    "French (France):fr:fr_FR.UTF-8"
    "German (Austria):de:de_AT.UTF-8"
    "German (Germany):de:de_DE.UTF-8"
    "German (Switzerland):de:de_CH.UTF-8"
    "Greek (Greece):el:el_GR.UTF-8"
    "Hebrew (Israel):he:he_IL.UTF-8"
    "Hindi (India):hi:hi_IN.UTF-8"
    "Hungarian (Hungary):hu:hu_HU.UTF-8"
    "Icelandic (Iceland):is:is_IS.UTF-8"
    "Indonesian (Indonesia):id:id_ID.UTF-8"
    "Irish (Ireland):ga:ga_IE.UTF-8"
    "Italian (Italy):it:it_IT.UTF-8"
    "Japanese (Japan):ja:ja_JP.UTF-8"
    "Kazakh (Kazakhstan):kk:kk_KZ.UTF-8"
    "Korean (South Korea):ko:ko_KR.UTF-8"
    "Latvian (Latvia):lv:lv_LV.UTF-8"
    "Lithuanian (Lithuania):lt:lt_LT.UTF-8"
    "Macedonian (North Macedonia):mk:mk_MK.UTF-8"
    "Malay (Malaysia):ms:ms_MY.UTF-8"
    "Maltese (Malta):mt:mt_MT.UTF-8"
    "Norwegian (Norway):no:no_NO.UTF-8"
    "Persian (Iran):fa:fa_IR.UTF-8"
    "Polish (Poland):pl:pl_PL.UTF-8"
    "Portuguese (Brazil):pt:pt_BR.UTF-8"
    "Portuguese (Portugal):pt:pt_PT.UTF-8"
    "Romanian (Romania):ro:ro_RO.UTF-8"
    "Russian (Russia):ru:ru_RU.UTF-8"
    "Serbian (Serbia):sr:sr_RS.UTF-8"
    "Slovak (Slovakia):sk:sk_SK.UTF-8"
    "Slovenian (Slovenia):sl:sl_SI.UTF-8"
    "Spanish (Argentina):es:es_AR.UTF-8"
    "Spanish (Bolivia):es:es_BO.UTF-8"
    "Spanish (Chile):es:es_CL.UTF-8"
    "Spanish (Colombia):es:es_CO.UTF-8"
    "Spanish (Costa Rica):es:es_CR.UTF-8"
    "Spanish (Cuba):es:es_CU.UTF-8"
    "Spanish (Dominican Republic):es:es_DO.UTF-8"
    "Spanish (Ecuador):es:es_EC.UTF-8"
    "Spanish (El Salvador):es:es_ES.UTF-8"
    "Spanish (Spain):es:es_GT.UTF-8"
    "Spanish (Guatemala):es:es_HN.UTF-8"
    "Spanish (Honduras):es:es_MX.UTF-8"
    "Spanish (Mexico):es:es_NI.UTF-8"
    "Spanish (Nicaragua):es:es_PA.UTF-8"
    "Spanish (Panama):es:es_PE.UTF-8"
    "Spanish (Paraguay):es:es_PR.UTF-8"
    "Spanish (Peru):es:es_PY.UTF-8"
    "Spanish (Puerto Rico):es:es_SV.UTF-8"
    "Spanish (Uruguay):es:es_US.UTF-8"
    "Spanish (Venezuela):es:es_UY.UTF-8"
    "Swedish (Sweden):sv:sv_SE.UTF-8"
    "Thai (Thailand):th:th_TH.UTF-8"
    "Turkish (Turkey):tr:tr_TR.UTF-8"
    "Ukrainian (Ukraine):uk:uk_UA.UTF-8"
    "Vietnamese (Vietnam):vi:vi_VN.UTF-8"
)

# Options for the YAD selector
KEYBOARD_OPTIONS=""
SYSTEM_OPTIONS=""
for i in "${LANGUAGES[@]}"; do
    NAME=$(echo "$i" | cut -d':' -f1)
    KEYBOARD_OPTIONS="$KEYBOARD_OPTIONS$NAME!"
    SYSTEM_OPTIONS="$SYSTEM_OPTIONS$NAME!"
done

KEYBOARD_OPTIONS="${KEYBOARD_OPTIONS::-1}"
SYSTEM_OPTIONS="${SYSTEM_OPTIONS::-1}"

# Get and format time zones
timezones=$(timedatectl list-timezones | sort)
timezones_options=$(echo "$timezones" | awk '{print $1}' | paste -sd'!' -)


response=$(yad --form \
    --center \
    --window-icon="$ICON_PATH" \
    --image="$ICON_PATH" \
    --title="$mytitle" \
    --width=300 \
    --height=200 \
    --field="$mytitle102":CB \
    "$KEYBOARD_OPTIONS" \
    --field="$mytitle103":CB \
    "$SYSTEM_OPTIONS" \
    --field="$mytitle104":CB \
    "$timezones_options" \
    --button="$mytitle105!${pics}yes.svg":0 \
    --button="$mytitle0!${pics}close.svg":1)


if [[ $? -ne 0 ]]; then
    exit 1
fi

keyboard_language=$(echo "$response" | awk -F '|' '{print $1}')
system_language=$(echo "$response" | awk -F '|' '{print $2}')
time_zone=$(echo "$response" | awk -F '|' '{print $3}')

# Function to apply language changes
apply_changes() {
    local SELECTION="$1"
    for i in "${LANGUAGES[@]}"; do
        NAME=$(echo "$i" | cut -d':' -f1)
        if [ "$SELECTION" == "$NAME" ]; then
            KEYMAP=$(echo "$i" | cut -d':' -f2)
            LOCALE=$(echo "$i" | cut -d':' -f3)
            echo "$KEYMAP" "$LOCALE"
            localectl set-keymap "$KEYMAP"
            localectl set-locale LANG="$LOCALE"

            sed -i "/^LANG=/d" /etc/environment
            echo "LANG=$LOCALE" | tee -a /etc/environment > /dev/null

            # Configure locales in /etc/locale.gen
            if ! grep -q "^${LOCALE}" /etc/locale.gen; then
                sed -i "/^#.*${LOCALE}/s/^#//" /etc/locale.gen
            fi
            break
        fi
    done
}

apply_changes "$keyboard_language"
apply_changes "$system_language"


timedatectl set-timezone "$time_zone"

echo "$time_zone" > /etc/timezone

locale-gen

# Notify the user
yad --info --center --window-icon="$ICON_PATH" --image="$ICON_PATH" --text="$mytitle106"
